Index: /trunk/contactcenter/setup/tables_update.inc.php
===================================================================
--- /trunk/contactcenter/setup/tables_update.inc.php	(revision 203)
+++ /trunk/contactcenter/setup/tables_update.inc.php	(revision 284)
@@ -56,24 +56,3 @@
 		return $GLOBALS['setup_info']['contactcenter']['currentver'];
 	}
-	$test[] = '1.0.005';
-	function contactcenter_upgrade1_0_005() {
-		$GLOBALS['setup_info']['contactcenter']['currentver'] = '1.14';
-		return $GLOBALS['setup_info']['contactcenter']['currentver'];
-	}
-	$test[] = '1.14';
-	function contactcenter_upgrade1_14() {				
-		$GLOBALS['phpgw_setup']->db->query("ALTER TABLE phpgw_cc_connections ALTER COLUMN connection_value TYPE varchar(100)");
-		$GLOBALS['setup_info']['contactcenter']['currentver'] = '1.150';
-		return $GLOBALS['setup_info']['contactcenter']['currentver'];
-	}
-	$test[] = '1.15';
-	function contactcenter_upgrade1_15() {
-		$GLOBALS['phpgw_setup']->db->query("ALTER TABLE phpgw_cc_contact ADD COLUMN last_status char(1) DEFAULT 'N'::bpchar");
-		$GLOBALS['phpgw_setup']->db->query("ALTER TABLE phpgw_cc_contact ADD COLUMN last_update int8 DEFAULT (date_part('epoch'::text, ('now'::text)::timestamp(3) with time zone) * (1000)::double precision)");
-		$GLOBALS['phpgw_setup']->db->query("ALTER TABLE phpgw_cc_contact ADD COLUMN category character varying(20)");
-
-		$GLOBALS['setup_info']['contactcenter']['currentver'] = '1.20';
-		return $GLOBALS['setup_info']['contactcenter']['currentver'];
-	}
-
 ?>
Index: /trunk/contactcenter/setup/external_catalogs.inc.php
===================================================================
--- /trunk/contactcenter/setup/external_catalogs.inc.php	(revision 284)
+++ /trunk/contactcenter/setup/external_catalogs.inc.php	(revision 284)
@@ -0,0 +1,47 @@
+<?php
+/*
+ * Created on 20/08/2007 Por Bruno costa
+ *
+ *	Arquivo de configuração de catálogos externos
+ *
+ */
+
+/*
+ * This file is comprised of two arrays describing the external catalogs ($external_srcs) and their attribute mappings
+ * ($external_mappings). The mapping between an external catalog and his attribute mappings are made with the array indices, i. e.
+ * a catalog at external_srcs with indice = 1 use the mapping with indice = 1 at external_mapping.
+ *
+ * external_srcs' format:
+ *
+ * 	$external_srcs	=	array(
+ * 					1	=>	array(
+ * 						'name'		=>	'Catalog's name',
+ * 						'host'		=>	'catalog's hostname',
+ * 						'dn'		=>	'catalog's base dn',
+ * 						'acc'		=>	'catalog's bind dn',
+ * 						'pw'		=>	'bind dn's password',
+ * 						'obj'		=>	'objectClass that will be used in searches',
+ * 						'branch'	=>	strtolower('attribute used as branches in the catalog tree'),
+ * 					),
+ * 					2 	=>	array(
+ * 						...
+ * 					),
+ * 	);
+ *
+ * external_mappings' format:
+ *
+ * 	$external_mappings	=	array(
+ *							1	=>	array(
+ *								'contact.id_contact'				=>	array('dn'),
+ *								'contact.photo'						=>	array('jpegPhoto'),
+ *								'contact.prefixes.prefix'			=>	false, //used when you don't have an attribute or don't want to use one
+ *								...
+ *							),
+ *							2	=>	array(
+ *								...
+ *							),
+ *		);
+ *
+ */
+
+ 
Index: /trunk/contactcenter/inc/ThreadUtility.inc.php
===================================================================
--- /trunk/contactcenter/inc/ThreadUtility.inc.php	(revision 284)
+++ /trunk/contactcenter/inc/ThreadUtility.inc.php	(revision 284)
@@ -0,0 +1,32 @@
+<?php
+	/***********************************************************************************\
+	* eGroupWare - Contacts Center                                              		*
+	* http://www.egroupware.org                                                 		*
+	* Written by:                                                               		*
+	*  - Brian W. Bosh from	Multi-threading strategies in PHP at						*
+	* http://www.alternateinterior.com/2007/05/multi-threading-strategies-in-php.html	*
+	* Adapted by:																		*
+	*  - Mário César Kolling <mario.kolling@serpro.gov.br>								*
+	* ----------------------------------------------------------------------------------*
+	*  This program is free software; you can redistribute it and/or modify it  		*
+	*  under the terms of the GNU General Public License as published by the    		*
+	*  Free Software Foundation; either version 2 of the License, or (at your   		*
+	*  option) any later version.                                               		*
+	\***********************************************************************************/
+
+	/*
+	 * Utility class used in the "Thread" solution
+	 */
+
+	function response ($status, $response) {
+		echo $status . "\n";
+		echo base64_encode(serialize($response)), "\n";
+	}
+	function processresponse ($string) {
+		$parts = explode ("\n", $string);
+		$status = $parts[0];
+		$data = unserialize (base64_decode ($parts[1]));
+		return array ("status" => $status, "data" => $data);
+	}
+
+?>
Index: /trunk/contactcenter/inc/class.bo_ldap_manager.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.bo_ldap_manager.inc.php	(revision 23)
+++ /trunk/contactcenter/inc/class.bo_ldap_manager.inc.php	(revision 284)
@@ -12,23 +12,24 @@
   \***************************************************************************/
 
-	
+
 	/*
 		This class is responsible for the LDAP control/generic functions and for
 		configuration gathering
 	*/
-
-	class bo_ldap_manager 
+	include_once('class.Thread.inc.php');
+
+	class bo_ldap_manager
 	{
-		
+
 		var $srcs;
 
-		
 		function bo_ldap_manager ()
 		{
+
 			if (!($this->srcs = $GLOBALS['phpgw']->session->appsession('bo_ldap_manager.srcs','contactcenter')))
 			{
 				$c = CreateObject('phpgwapi.config','contactcenter');
 				$data = $c->read_repository();
-				
+
 				if (!$data or $data['cc_global_source0'] !== 'ldap')
 				{
@@ -36,5 +37,5 @@
 					return;
 				}
-				
+
 				$this->srcs = array(
 					1 => array(
@@ -47,4 +48,5 @@
 						'branch' => strtolower('ou')
 					)
+
 				);
 			}
@@ -54,11 +56,11 @@
 		{
 		}
-	
+
 		/*
-		
+
 			@function get_all_ldap_sources
 			@abstract Returns an array containing all LDAP sources informations
 			@author Raphael Derosso Pereira
-		
+
 			@return array All LDAP information
 				$return = array(
@@ -67,9 +69,9 @@
 						'dn'   => (string),
 						'acc'  => (string),
-						'pw'   => (string)   
+						'pw'   => (string)
 					),
 					...
 				)
-				
+
 			TODO: Return multiple sources...
 		*/
@@ -78,8 +80,27 @@
 			return $this->srcs;
 		}
-		
+
+		/*
+		* @function get_external_ldap_sources
+		* @author Mário César Kolling <mario.kolling@serpro.gov.br>
+		* @abstract returns an array with the external sources
+		* @return (array) the external sources
+		*/
+
+		function get_external_ldap_sources()
+		{
+			include(PHPGW_INCLUDE_ROOT . '/contactcenter/setup/external_catalogs.inc.php' );
+			//include('external_catalogs.inc.php' );
+			return $external_srcs;
+		}
+
+		/*
+		 * @function get_ldap_fields_association
+		 * @abstract get the fields associantion for ldap source
+		 * @return an array with attribute mappings
+		 */
 		function get_ldap_fields_association ( $id_source )
 		{
-			
+
 			$op_iop = array(
 				'contact.id_contact'               => array('dn'),
@@ -90,4 +111,5 @@
 				'contact.family_names'             => array('sn'),
 				'contact.names_ordered'            => array('cn'),//,'displayName'),
+
 				'contact.suffixes.suffix'          => false,
 				'contact.birthdate'                => false,
@@ -95,11 +117,15 @@
 				'contact.pgp_key'                  => false,
 				'contact.notes'                    => false,
-				'contact.mail_forwarding_address' => array('mailForwardingAddress'),
-				'contact.account_type' => array('phpgwAccountType'),
+				'contact.mail_forwarding_address'  => array('mailForwardingAddress'),
+				'contact.account_type'             => array('phpgwAccountType'),
+				'contact.account_status'           => array('phpgwAccountStatus'),
+				'contact.account_visible'          => array('phpgwAccountVisible'),
+				'contact.object_class'             => array('objectClass'),
 				'contact.business_info.title'      => array('title'),
-				'contact.business_info.department' => array('ou'),
+				'contact.business_info.department' => array('ou'), // Setor do empregado...
+				'contact.business_info.empNumber'  => array('employeeNumber'), // Matricula do empregado
 				'contact.company.company_name'     => array('o'),
 				'contact.company.company_notes'    => array('businessCategory'),
-				
+
 				'contact.contact_related.names_ordered' => 'contact.contact_related.typeof_relation.contact_relation_name',
 				'contact.contact_related.typeof_relation.contact_relation_name' =>  array(
@@ -107,30 +133,30 @@
 					'secretary' => array('secretary')
 				),
-				
+
 				'contact.address.address1'         => 'contact.address.typeof_address.contact_address_type_name',
 				'contact.address.typeof_address.contact_address_type_name' => array(
 					'home' => array('street', 'st', 'postalAddress', 'homePostalAddress'),
 				),
-				
+
 				'contact.address.postal_code'      => 'contact.address.typeof_address.contact_address_type_name',
 				'contact.address.typeof_address.contact_address_type_name' => array(
 					'home' => array('PostalCode'),
 				),
-				
+
 				'contact.address.city.city_name'   => 'contact.address.typeof_address.contact_address_type_name',
 				'contact.address.typeof_address.contact_address_type_name' => array(
 					'home' => array('l'),
 				),
-				
+
 				'contact.address.city.state.state_name'       => 'contact.address.typeof_address.contact_address_type_name',
 				'contact.address.typeof_address.contact_address_type_name' => array(
 					'home' => false,
 				),
-				
+
 				'contact.address.city.country.id_country'     => 'contact.address.typeof_address.contact_address_type_name',
 				'contact.address.typeof_address.contact_address_type_name' => array(
 					'home' => array('c')
 				),
-				
+
 				'contact.connection.connection_value'         => 'contact.connection.typeof_connection.contact_connection_type_name',
 				'contact.connection.typeof_connection.contact_connection_type_name' => array (
@@ -143,23 +169,81 @@
 				),
 			);
-			
+
 			return $op_iop;
+
+		}
+
+		/*
+		 * @function get_external_ldap_fields_association
+		 * @author Mário César Kolling <mario.kolling@serpro.gov.br>
+		 * @abstract get the fields association for an external ldap_source
+		 * @return an array with attribute mappings
+		 */
+		function get_external_ldap_fields_association ( $id_source )
+		{
+			include(PHPGW_INCLUDE_ROOT . '/contactcenter/setup/external_catalogs.inc.php' );
+			//include('external_catalogs.inc.php' );
+			return $external_mappings[$id_source];
+		}
+
+		/*
+		 * @function test_connection
+		 * @author Mário César Kolling <mario.kolling@serpro.gov.br>
+		 * @abstract Test if we can bind to a ldap server in a reasonable time
+		 * @param (string) $host ldap server's hostname
+		 * @param (string) $account ldap bind dn
+		 * @param (string) $password a bind dn's password
+		 * @return (array) an array with the answer from the subprocess, null otherwise
+		 */
+		function test_connection($host, $account, $password, $timeout = 5)
+		{
+			//opens a subprocess for nonblocking bind
+			$tsearch = Thread::Create('class.ldap_assync.inc.php', array('host'	=> $host,
+																'account'	=> $account,
+																'password'	=> $password
+																)
+			);
+
+			// It's problably more efficient to let method readResponse control the timeout through
+			// stream_select native timeout.
+			$response = NULL;
+			for ($i = 0; $i < $timeout; $i++)
+			{
+				if ($tsearch->isActive())
+				{
+					sleep(1);
+					if (($response = $tsearch->readResponse()) !== NULL)
+					{
+						$tsearch->close();
+						return $response;
+					}
+
+				}
+				else
+				{
+					$response = $tsearch->readResponse();
+					break;
+				}
+			}
+
+			$tsearch->close();
+			return null;
 		}
 
 		/*!
-		
+
 			@function get_ldap_tree
 			@abstract Returns the LDAP tree corresponding to the specified level
 			@author Raphael Derosso Pereira
-			
+
 			@param (integer) $id_source The ID of the LDAP source
-			
+
 			@param (string)  $context The context to be used as root branch
-				
+
 			@param (boolean) $recursive Make it a recursive construction.
 				CAUTION! This is EXTREMELY SLOW on large LDAP databases,
 				specially when they're not indexed
-		*/		
-		function get_ldap_tree($id_source, $context = false, $recursive = false) 
+		*/
+		function get_ldap_tree($id_source, $context = false, $recursive = false)
 		{
 			if (!$this->srcs[$id_source])
@@ -167,5 +251,5 @@
 				return null;
 			}
-			
+
 			$ldap = $GLOBALS['phpgw']->common->ldapConnect($this->srcs[$id_source]['host'], $this->srcs[$id_source]['acc'],$this->srcs[$id_source]['pw'], false);
 			if (!$ldap)
@@ -173,5 +257,5 @@
 				return false;
 			}
-			
+
 			if ($recursive)
 			{
@@ -181,8 +265,59 @@
 				return $tree;
 			}
-			
-			return $this->get_ldap_tree_level($id_source, $ldap, $context, $this->srcs[$id_source]['obj'],$this->srcs[$id_source]['branch']);
-		}
-
+
+			return $this->get_ldap_tree_level($id_source, $ldap, $context, $this->srcs[$id_source]['obj'],$this->srcs[$id_source]['branch'], 0);
+		}
+
+		/*!
+
+			@function get_external_ldap_tree
+			@abstract Returns the LDAP external tree corresponding to the specified level
+			@author Mário César Kolling <mario.kolling@serpro.gov.br>
+			@param (integer) $id_source The ID of the external LDAP source
+			@param (string)  $context The context to be used as root branch
+			@param (boolean) $recursive Make it a recursive construction.
+				CAUTION! This is EXTREMELY SLOW on large LDAP databases,
+				specially when they're not indexed
+		*/
+		function get_external_ldap_tree($id_source, $context = false, $recursive = false)
+		{
+
+
+			include(PHPGW_INCLUDE_ROOT . '/contactcenter/setup/external_catalogs.inc.php' );
+			//include('external_catalogs.inc.php' );
+
+			if (!$external_srcs[$id_source])
+			{
+				return null;
+			}
+
+			// calls test_connection first. If succeeded continue, return error message otherwise.
+			if (!($response = $this->test_connection($external_srcs[$id_source]['host'], $external_srcs[$id_source]['acc'], $external_srcs[$id_source]['pw'], 10)))
+			{
+				return array(
+					'msg'		=>	lang("Catalog %1 temporarily unavailable. Please try again later!", $external_srcs[$id_source]['name']),
+					'timeout'	=>	'true'
+				);
+			}
+
+			$ldap = $GLOBALS['phpgw']->common->ldapConnect($external_srcs[$id_source]['host'], $external_srcs[$id_source]['acc'],$external_srcs[$id_source]['pw'], false);
+			if (!$ldap)
+			{
+				return false;
+			}
+
+			// Option recursive commented out
+			/*
+			if ($recursive)
+			{
+				$tree = $this->get_ldap_tree_recursive($ldap, $context, $this->srcs[$id_source]['obj'],$this->srcs[$id_source]['branch']);
+				$tree['recursive'] = true;
+
+				return $tree;
+			}
+			*/
+
+			return $this->get_ldap_tree_level($id_source, $ldap, $context, $external_srcs[$id_source]['obj'],$external_srcs[$id_source]['branch'], 1);
+		}
 
 		/*!
@@ -201,5 +336,5 @@
 				return null;
 			}
-			
+
 			$count = ldap_count_entries($resource,$result_res);
 			if ( $count == 0 )
@@ -218,14 +353,16 @@
 				}
 			}
-			
+
 			$entries = ldap_get_entries($resource, $result_res);
-			
+
 			for ($i = 0; $i < $entries['count']; $i++)
 			{
 				$subtree = $this->get_ldap_tree_recursive($resource, $entries[$i]['dn'], $objectClass);
-				
+
 				$dn_parts=ldap_explode_dn($entries[$i]['dn'],1);
-				
-				if ($subtree !== null and is_array($subtree)) 
+
+
+
+				if ($subtree !== null and is_array($subtree))
 				{
 					$tree[$i]['name'] = $dn_parts[0];
@@ -244,5 +381,5 @@
 						'sub_branch' => false
 					);
-				} 
+				}
 			}
 
@@ -256,17 +393,17 @@
 			}
 		}
-		
+
 		function get_ldap_referrals($ds, $dn, $filter) {
-			
+
 			ldap_set_option($ds, LDAP_OPT_REFERRALS, 0);
 			ldap_set_option($ds,LDAP_OPT_PROTOCOL_VERSION,3);
-			
+
 			if ($ds) {
 			    ldap_bind($ds);
-			   	$sr=ldap_list($ds,$dn, $filter);		    
+			   	$sr=ldap_list($ds,$dn, $filter);
 			   	$ref = ldap_first_reference($ds, $sr);
 			   	$array_referral = array();
 			   	$idx = 0;
-			    	
+
 				 while ($ref) {
 					$array_referral[$idx++] = ldap_get_dn($ds, $ref);
@@ -275,50 +412,82 @@
 				return $array_referral;
 			}
-			else 
+			else
 				return false;
 		}
 
 		function get_ldap_sub_branches_referrals($ds, $dn, $filter) {
-			
+
 			$referral = $this -> get_ldap_referrals($ds, $dn, $filter);
 			$sub_branches = array();
-			
+
 			for($i = 0; $i <count($referral); $i++) {
 				$dn = str_replace("??base","",preg_replace('!^(ldap://[^/]+)/(.*$)!', '\\2', $referral[$i]));
-				$dn = explode(",",$dn);				
+				$dn = explode(",",$dn);
 				$dn = strtoupper(str_replace("ou=", "",$dn[0]));
 				$dn = str_replace("DC=", "",$dn);
-																						
+
 				$sub_branch = array(
 											'name' => $dn,
 					                    	'type' => 'unknown',
                     						'value' => $referral[$i],
-                    						'sub_branch' => false		
-										);															
-				$sub_branches[$i] = $sub_branch;			
+                    						'sub_branch' => false
+										);
+				$sub_branches[$i] = $sub_branch;
 			}
 			return $sub_branches;
 		}
-		
-
-		function get_ldap_tree_level($id_source, $resource, $context, $objectClass, $branch_dn)
+
+		function translate_accentuation($text)
+		{
+			/*
+			 * Esta operação resolve o problema causado pela conversão de caracteres acentuados realizada
+			 * pela função ldap_explode_dn().
+			 */
+
+			return utf8_decode(preg_replace("/\\\([0-9A-Fa-f]{2})/e", "''.chr(hexdec('\\1')).''", $text));
+		}
+
+		function get_ldap_tree_level($id_source, $resource, $context, $objectClass, $branch_dn, $external = 0)
 		{
 			if(strstr($context, "ldap://")){
-				$refer_context = str_replace("??base","",preg_replace('!^(ldap://[^/]+)/(.*$)!', '\\2', $context));												
-				$host	= preg_replace('!^(ldap://[^/]+)/.*$!', '\\1', $context);																
+				$refer_context = str_replace("??base","",preg_replace('!^(ldap://[^/]+)/(.*$)!', '\\2', $context));
+				$host	= preg_replace('!^(ldap://[^/]+)/.*$!', '\\1', $context);
 				$resource = ldap_connect($host);
-				ldap_bind($resource);	
-			}
-			$dn_parts = ldap_explode_dn(($refer_context ? $refer_context : $context),1);			
+				ldap_bind($resource);
+			}
+
+			/*
+			 * TODO: Search timeouts
+			 */
+
+			$dn_parts = ldap_explode_dn(($refer_context ? $refer_context : $context),1);
 			//$filter = '(!(objectClass='.$objectClass.'))';
 			// Don't show OU's whith phpgwAccountVisible equal to '-1'
-			$filter = '(&(!(objectClass='.$objectClass.')) (!(phpgwAccountVisible=-1)))';
-			$result_res = @ldap_list($resource,  ($refer_context ? $refer_context : $context), $filter);
+
+			if ($external)
+			{
+				// external source: get all organizationalUnits
+				$filter = '(objectClass=organizationalUnit)';
+			}
+			else
+			{
+				// get any objectClass except the objectClass used for the source
+				// and whose attribute phpgwAccountVisible value is different from -1
+				$filter = '(&(!(objectClass='.$objectClass.')) (!(phpgwAccountVisible=-1)))';
+			}
+			$result_res = @ldap_list($resource,  ($refer_context ? $refer_context : $context), $filter, array(), 0, 0);
 			@ldap_sort($resource, $result_res, 'ou');
 
+			// Timeouts commented out
+			/*
 			if ($result_res === false)
 			{
+				if (ldap_errno($resource) === 3)
+				{
+					return array('error_msg' => ldap_error($resource));
+				}
 				return null;
 			}
+			*/
 
 			$count = ldap_count_entries($resource,$result_res);
@@ -326,6 +495,7 @@
 			if ( $count == 0 )
 			{
-				$filter = 'objectClass='.$objectClass;
-				$result_res2 = @ldap_list($resource, ($refer_context ? $refer_context : $context), $filter);
+				$filter = '(objectClass='.$objectClass.')';
+				// Get only one attribute of the source's objectClass
+				$result_res2 = @ldap_list($resource, ($refer_context ? $refer_context : $context), $filter, Array('cn'), 0, 1);
 				$entries_count = ldap_count_entries($resource, $result_res2);
 
@@ -333,8 +503,9 @@
 				{
 					return array(
-						'name'       => $dn_parts[0],
+						'name'       => $this->translate_accentuation($dn_parts[0]),
 						'type'       => 'catalog',
 						'class'      => 'bo_global_ldap_catalog',
-						'class_args' => array($id_source, $context),
+						// Pass the variable $external as a parameter to the constructor
+						'class_args' => array($id_source, $context, $external),
 						'icon'       => 'globalcatalog-mini.png',
 						'value'      => $context,
@@ -345,5 +516,5 @@
 				{
 					return array(
-						'name' => $dn_parts[0],
+						'name' => $this->translate_accentuation($dn_parts[0]),
 						'type' => 'empty'
 					);
@@ -361,12 +532,13 @@
 				$dn_parts_full = ldap_explode_dn($dn,0);
 				list($group) = explode('=',$dn_parts_full[0]);
-				
-				if ($group == $branch_dn or $branch_dn === 'all')
+
+				//Faz a comparação do branch como case insensitive
+				if (strtolower($group) == strtolower($branch_dn) or $branch_dn === 'all')
 				{
 					$tree['sub_branch'][$i] = array(
-						'name'  => $dn_parts_1[0],
+						'name'  => $this->translate_accentuation($dn_parts_1[0]),
 						'type'  => 'unknown',
 						'value' =>  ($refer_context ? $host."/" : "").$dn,
-						'sub_branch' => false					
+						'sub_branch' => false
 					);
 					$sub_branch_found = true;
@@ -374,5 +546,5 @@
 				$i++;
 			}
-			
+
 			if(! $refer_context) {
 				$array_referral = $this -> get_ldap_sub_branches_referrals($resource, $context,'(objectClass=organizationalUnit)');
@@ -383,13 +555,14 @@
 
 			$filter = 'objectClass='.$objectClass;
-			$result_res2 = @ldap_list($resource, ($refer_context ? $refer_context : $context), $filter);
+			$result_res2 = @ldap_list($resource, ($refer_context ? $refer_context : $context), $filter, Array('cn'), 0, 1);
 			$entries_count = ldap_count_entries($resource, $result_res2);
 
 			if ($result_res2 !== false && $entries_count > 0 && $sub_branch_found)
 			{
-				$tree['name']       = $dn_parts[0];
+				$tree['name']       = $this->translate_accentuation($dn_parts[0]);
 				$tree['type']       = 'mixed_catalog_group';
 				$tree['class']      = 'bo_global_ldap_catalog';
-				$tree['class_args'] = array($id_source,$context);
+				// Pass the variable $external as a parameter to the constructor
+				$tree['class_args'] = array($id_source,$context,$external);
 				$tree['icon']       = 'globalcatalog-mini.png';
 				$tree['value']      = $context;
@@ -398,8 +571,9 @@
 			{
 				return array(
-					'name'       => $dn_parts[0],
+					'name'       => $this->translate_accentuation($dn_parts[0]),
 					'type'       => 'catalog',
 					'class'      => 'bo_global_ldap_catalog',
-					'class_args' => array($id_source, $context),
+					// Pass the variable $external as a parameter to the constructor
+					'class_args' => array($id_source, $context,$external),
 					'icon'       => 'globalcatalog-mini.png',
 					'value'      => $context,
@@ -409,12 +583,12 @@
 			else
 			{
-				$tree['name']       = $dn_parts[0];
+				$tree['name']       = $this->translate_accentuation($dn_parts[0]);
 				$tree['type']       = 'catalog_group';
 				$tree['class']      = 'bo_catalog_group_catalog';
-				$tree['class_args'] = array('$this', '$this->get_branch_by_level($this->catalog_level[0])');
+				// Pass the variable $external as a parameter to the constructor
+				$tree['class_args'] = array('$this', '$this->get_branch_by_level($this->catalog_level[0])', $external);
 				$tree['value']      = $context;
 				$tree['ldap']       = array('id_source' => $id_source, 'context' => $context);
 			}
-			
 			usort($tree['sub_branch'], array($this, "compareTreeNodes"));
 			return $tree;
@@ -422,7 +596,7 @@
 
 		function compareTreeNodes($a, $b)	{
-						
+
 			return strnatcasecmp($a['name'], $b['name']);
-		}	
+		}
 
 	}
Index: /trunk/contactcenter/inc/class.so_group.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.so_group.inc.php	(revision 258)
+++ /trunk/contactcenter/inc/class.so_group.inc.php	(revision 284)
@@ -117,5 +117,5 @@
 			'A.id_contact = B.id_contact and B.id_connection = C.id_connection and '.
 			'C.connection_is_default = true and B.id_typeof_contact_connection = 1 and '.
-			'A.id_owner ='.$this->owner.' order by A.names_ordered,C.connection_value';
+			'A.id_owner ='.$this->owner.' order by A.names_ordered';
 
 					
Index: /trunk/contactcenter/inc/class.bo_catalog_group_catalog.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.bo_catalog_group_catalog.inc.php	(revision 2)
+++ /trunk/contactcenter/inc/class.bo_catalog_group_catalog.inc.php	(revision 284)
@@ -20,8 +20,10 @@
 
 	include_once('class.abo_catalog.inc.php');
-	
+
 	class bo_catalog_group_catalog extends abo_catalog
 	{
-			
+
+		var $external;
+
 		var $fields = array(
 			'id_contact'    => true,
@@ -38,5 +40,5 @@
 			'pgp_key'       => true,
 			'notes'         => true,
-			
+
 			/* Array fields */
 			'companies'     => true,
@@ -45,18 +47,19 @@
 			'connections'   => true
 		);
-	
-		/*!
-		
+
+		/*!
+
 		 @function bo_people_catalog
 		 @abstract Constructor
 	 	 @author Raphael Derosso Pereira
-	 	 
+
 	 	*/
-		function bo_catalog_group_catalog(& $bo_contactcenter, & $catalog)
+		function bo_catalog_group_catalog(& $bo_contactcenter, & $catalog, $external = 0)
 		{
 			$this->bo_contactcenter = & $bo_contactcenter;
 			$this->catalog = & $catalog;
-		}
-		 	
+			$this->external = $external;
+		}
+
 
 		/*!
@@ -68,5 +71,5 @@
 
 		 @param SEE class bo_contactcenter for usage
-		
+
 		*/
 		function find($what, $rules, $other)
@@ -74,10 +77,11 @@
 			if ($ldap_info = $this->catalog['ldap'])
 			{
-				$meta_catalog =& CreateObject('contactcenter.bo_global_ldap_catalog',$ldap_info['id_source'], $ldap_info['context']);
+
+				$meta_catalog =& CreateObject('contactcenter.bo_global_ldap_catalog',$ldap_info['id_source'], $ldap_info['context'], $this->external);
 				return $meta_catalog->find($what, $rules, $other);
 			}
-			
+
 			$results = array();
-			
+
 			reset($this->catalog);
 			while(list(, $new_catalog) = each($this->catalog['sub_branch']))
@@ -86,12 +90,12 @@
 				//echo 'Setting catalog: <b>'.$new_catalog['name'].'</b><br>';
 				$new_catalog = $this->bo_contactcenter->set_catalog($new_catalog);
-				
+
 				//if($new_catalog) echo 'Setado corretamente!<br><br>'; else echo 'Erro ao setar<br><br>';
-				
+
 				if ($new_catalog['type'] === 'empty')
 				{
 					continue;
 				}
-				
+
 				$temp_res = $this->bo_contactcenter->catalog->find($what, $rules, $other);
 				if (is_array($temp_res) and count($temp_res))
@@ -107,21 +111,21 @@
 			return $result;
 		}
-		
-		/*!
-		
+
+		/*!
+
 		 @function get_single_entry
 		 @abstract Returns all information requested about one contact
 		 @author Raphael Derosso Pereira
-		     
+
 		 @param integer $id_contact The contact ID
 		 @param array $fields The array returned by get_fields whith true
 		 	on the fields to be taken.
-		 	
+
 		*/
 		function get_single_entry ( $id_contact, $fields )
-		{	
-			if (!is_array($fields)) 
-			{
-				if (is_object($GLOBALS['phpgw']->log)) 
+		{
+			if (!is_array($fields))
+			{
+				if (is_object($GLOBALS['phpgw']->log))
 				{
 					$GLOBALS['phpgw']->log->message(array(
@@ -129,15 +133,15 @@
 						'line' => __LINE__,
 						'file' => __FILE__));
-					
+
 					$GLOBALS['phpgw']->log->commit();
 				}
-				else 
+				else
 				{
 					exit('Argument Error on: <br>File:'.__FILE__.'<br>Line:'.__LINE__.'<br>');
 				}
 			}
-			
+
 			$contact_array = $this->get_multiple_entries(array($id_contact), $fields);
-			
+
 			if (!count($contact_array))
 			{
@@ -149,15 +153,15 @@
 			else
 				$contact_data = $contact_array[$id_contact];
-			
+
 			if (!is_array($contact_data))
 			{
 				return false;
 			}
-			
+
 			return $contact_data;
 		}
-	
-		/*!
-		 
+
+		/*!
+
 		 @function get_multiple_entries
 		 @abstract Returns multiple Contacts data into one array
@@ -172,6 +176,6 @@
 		 		'sort'      => <sort>,
 		 		'order_by'  => <order by>
-		 	); 
-		
+		 	);
+
 		*/
 		function get_multiple_entries ( $id_contacts, $fields, $other_data = false )
@@ -179,5 +183,5 @@
 			if (!is_array($id_contacts) or !is_array($fields) or ($other_data != false and !is_array($other_data)))
 			{
-				if (is_object($GLOBALS['phpgw']->log)) 
+				if (is_object($GLOBALS['phpgw']->log))
 				{
 					$GLOBALS['phpgw']->log->message(array(
@@ -185,5 +189,5 @@
 						'line' => __LINE__,
 						'file' => __FILE__));
-					
+
 					$GLOBALS['phpgw']->log->commit();
 				}
@@ -192,12 +196,14 @@
 				}
 			}
-			
+
 			$contacts = array();
-	
+
 			if ($other_data)
 			{
 				//TODO
 			}
-	
+
+			//error_log("bo_ldap_catalog_group_catalog->get_multiple_entries \n", 3, '/var/www/teste.log');
+
 			/* First check if this is a LDAP Catalog Group. In this case, just leave the
 			 * subtree search for the LDAP server
@@ -205,8 +211,8 @@
 			if ($ldap_info = $this->catalog['ldap'])
 			{
-				$meta_catalog = CreateObject('contactcenter.bo_global_ldap_catalog', $ldap_info['id_source'], $ldap_info['context']);
+				$meta_catalog = CreateObject('contactcenter.bo_global_ldap_catalog', $ldap_info['id_source'], $ldap_info['context'], $this->external);
 				return $meta_catalog->get_multiple_entries($id_contacts, $fields, $other_data);
 			}
-			
+
 			/* Search for the catalog of the first entry and try to get all ids from that
 			 * catalog. Repeat to the ones not found until there's none missing or no more
@@ -220,5 +226,5 @@
 				$this->bo_contactcenter->set_catalog($branch);
 				$contacts += $this->bo_contactcenter->catalog->get_multiple_entries($id_contacts, $fields, $other_data);
-				
+
 				reset($contacts);
 				while (list($id) = each($contacts))
@@ -237,8 +243,8 @@
 
 			$this->bo_contactcenter->set_catalog($this->catalog);
-			
+
 			return $contacts;
 		}
-	
+
 		function get_all_entries_ids ()
 		{
@@ -246,9 +252,9 @@
 			return null;
 		}
-		
+
 		/*********************************************************************\
 		 *                Methods to get general fields                      *
 		\*********************************************************************/
-		
+
 		/*********************************************************************\
 		 *                   Methods to Include Data                         *
